# Example: ebgp in chain

## **Topology diagram**

![topology](/img/topo.tst.png)

## **Configuration**

**r1:**
```
hostname r1
buggy
!
logging file debug ./slot0r1-log.run
!
vrf definition tester
 exit
!
vrf definition v1
 rd 1:1
 exit
!
interface loopback0
 vrf forwarding v1
 ipv4 address 2.2.2.1 255.255.255.255
 ipv6 address 4321::1 ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding v1
 ipv4 address 5.5.5.2 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
ipv4 route v1 0.0.0.0 0.0.0.0 5.5.5.1
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r2:**
```
hostname r2
buggy
!
logging file debug ./slot0r2-log.run
!
vrf definition tester
 exit
!
vrf definition v1
 rd 1:1
 exit
!
interface loopback0
 vrf forwarding v1
 ipv4 address 2.2.2.2 255.255.255.255
 ipv6 address 4321::2 ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding v1
 ipv4 address 5.5.5.6 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
ipv4 route v1 0.0.0.0 0.0.0.0 5.5.5.5
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r3:**
```
hostname r3
buggy
!
logging file debug ./slot0r3-log.run
!
route-policy ibgp-in
 sequence 10 if rd 1:2
 sequence 20   set nexthop 1.1.111.2
 sequence 30   set vrf v2 ipv4
 sequence 40   pass
 sequence 50 enif
 sequence 60 if rd 1:3
 sequence 70   set nexthop 1.1.222.2
 sequence 80   set vrf v3 ipv4
 sequence 90   pass
 sequence 100 enif
 sequence 110 drop
 exit
!
vrf definition tester
 exit
!
vrf definition v1
 rd 1:1
 exit
!
vrf definition v2
 rd 1:2
 rt4import 1:2
 rt4export 1:2
 rt6import 1:2
 rt6export 1:2
 clr4import 2
 clr4export 2
 clr6import 2
 clr6export 2
 exit
!
vrf definition v3
 rd 1:3
 rt4import 1:3
 rt4export 1:3
 rt6import 1:3
 rt6export 1:3
 clr4import 3
 clr4export 3
 clr6import 3
 clr6export 3
 exit
!
router isis4 1 vrf v1
 upgrade-cli
 net-id 48.0000.0000.3333.00
 traffeng-id ::
 is-type level2
 level2 traffeng
 redistribute connected
 exit
!
interface loopback0
 vrf forwarding v1
 ipv4 address 2.2.2.3 255.255.255.255
 ipv6 address 4321::3 ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
 no shutdown
 no log-link-change
 exit
!
interface loopback2
 vrf forwarding v2
 ipv4 address 3.3.3.3 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface loopback3
 vrf forwarding v3
 ipv4 address 4.4.4.3 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding v2
 ipv4 address 5.5.5.1 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
interface ethernet2
 lldp enable
 vrf forwarding v3
 ipv4 address 5.5.5.5 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
interface ethernet3
 lldp enable
 no shutdown
 no log-link-change
 exit
!
interface ethernet3.111
 vrf forwarding v1
 ipv4 address 1.1.1.1 255.255.255.252
 mpls enable
 mpls rsvp4
 router isis4 1 enable
 router isis4 1 circuit level2
 no shutdown
 no log-link-change
 exit
!
interface ethernet3.222
 vrf forwarding v1
 ipv4 address 1.1.1.5 255.255.255.252
 mpls enable
 mpls rsvp4
 router isis4 1 enable
 router isis4 1 circuit level2
 no shutdown
 no log-link-change
 exit
!
interface tunnel1
 tunnel vrf v1
 tunnel source loopback0
 tunnel destination 1.1.1.2
 tunnel mode p2pte
 vrf forwarding v2
 ipv4 address 1.1.111.1 255.255.255.252
 mpls enable
 no shutdown
 no log-link-change
 exit
!
interface tunnel2
 tunnel vrf v1
 tunnel source loopback0
 tunnel destination 1.1.1.6
 tunnel mode p2pte
 vrf forwarding v3
 ipv4 address 1.1.222.1 255.255.255.252
 mpls enable
 no shutdown
 no log-link-change
 exit
!
router bgp4 1 vrf v1
 upgrade-cli
 local-as 1
 router-id 2.2.2.3
 address-family unicast
 neighbor 2.2.2.4 remote-as 1
 neighbor 2.2.2.4 local-as 1
 neighbor 2.2.2.4 address-family vpnuni
 neighbor 2.2.2.4 distance 200
 neighbor 2.2.2.4 update-source loopback0
 neighbor 2.2.2.4 send-community all
 neighbor 2.2.2.4 vpn-route-policy-in ibgp-in
 afi-vrf v2 enable
 afi-vrf v2 redistribute connected
 afi-vrf v3 enable
 afi-vrf v3 redistribute connected
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r4:**
```
hostname r4
buggy
!
logging file debug ./slot0r4-log.run
!
route-policy ibgp-in
 sequence 10 if rd 1:2
 sequence 20   set nexthop 1.1.111.1
 sequence 30   set vrf v2 ipv4
 sequence 40   pass
 sequence 50 enif
 sequence 60 if rd 1:3
 sequence 70   set nexthop 1.1.222.1
 sequence 80   set vrf v3 ipv4
 sequence 90   pass
 sequence 100 enif
 sequence 110 drop
 exit
!
vrf definition tester
 exit
!
vrf definition v1
 rd 1:1
 exit
!
vrf definition v2
 rd 1:2
 rt4import 1:2
 rt4export 1:2
 rt6import 1:2
 rt6export 1:2
 clr4import 2
 clr4export 2
 clr6import 2
 clr6export 2
 exit
!
vrf definition v3
 rd 1:3
 rt4import 1:3
 rt4export 1:3
 rt6import 1:3
 rt6export 1:3
 clr4import 3
 clr4export 3
 clr6import 3
 clr6export 3
 exit
!
router isis4 1 vrf v1
 upgrade-cli
 net-id 48.0000.0000.4444.00
 traffeng-id ::
 is-type level2
 level2 traffeng
 redistribute connected
 exit
!
interface loopback0
 vrf forwarding v1
 ipv4 address 2.2.2.4 255.255.255.255
 ipv6 address 4321::4 ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
 no shutdown
 no log-link-change
 exit
!
interface loopback2
 vrf forwarding v2
 ipv4 address 3.3.3.4 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface loopback3
 vrf forwarding v3
 ipv4 address 4.4.4.4 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 no shutdown
 no log-link-change
 exit
!
interface ethernet1.111
 vrf forwarding v1
 ipv4 address 1.1.1.2 255.255.255.252
 mpls enable
 mpls rsvp4
 router isis4 1 enable
 router isis4 1 circuit level2
 no shutdown
 no log-link-change
 exit
!
interface ethernet1.222
 vrf forwarding v1
 ipv4 address 1.1.1.6 255.255.255.252
 mpls enable
 mpls rsvp4
 router isis4 1 enable
 router isis4 1 circuit level2
 no shutdown
 no log-link-change
 exit
!
interface ethernet2
 lldp enable
 vrf forwarding v1
 ipv4 address 1.1.1.9 255.255.255.252
 mpls enable
 no shutdown
 no log-link-change
 exit
!
interface tunnel1
 tunnel vrf v1
 tunnel source loopback0
 tunnel destination 1.1.1.1
 tunnel mode p2pte
 vrf forwarding v2
 ipv4 address 1.1.111.2 255.255.255.252
 mpls enable
 no shutdown
 no log-link-change
 exit
!
interface tunnel2
 tunnel vrf v1
 tunnel source loopback0
 tunnel destination 1.1.1.5
 tunnel mode p2pte
 vrf forwarding v3
 ipv4 address 1.1.222.2 255.255.255.252
 mpls enable
 no shutdown
 no log-link-change
 exit
!
router bgp4 1 vrf v1
 upgrade-cli
 local-as 1
 router-id 2.2.2.4
 address-family unicast
 neighbor 2.2.2.3 remote-as 1
 neighbor 2.2.2.3 local-as 1
 neighbor 2.2.2.3 address-family vpnuni
 neighbor 2.2.2.3 distance 200
 neighbor 2.2.2.3 update-source loopback0
 neighbor 2.2.2.3 send-community all
 neighbor 2.2.2.3 vpn-route-policy-in ibgp-in
 afi-vrf v2 enable
 afi-vrf v2 redistribute connected
 afi-vrf v2 redistribute bgp4 2
 afi-vrf v3 enable
 afi-vrf v3 redistribute connected
 afi-vrf v3 redistribute bgp4 2
 exit
!
router bgp4 2 vrf v1
 upgrade-cli
 local-as 1
 router-id 2.2.2.4
 no safe-ebgp
 address-family unicast
 neighbor 1.1.1.10 remote-as 2
 neighbor 1.1.1.10 local-as 1
 neighbor 1.1.1.10 address-family ctp
 neighbor 1.1.1.10 distance 20
 neighbor 1.1.1.10 send-community all
 afi-clr v2 enable
 afi-clr v2 redistribute connected
 afi-clr v2 redistribute bgp4 1
 afi-clr v3 enable
 afi-clr v3 redistribute connected
 afi-clr v3 redistribute bgp4 1
 redistribute connected
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r5:**
```
hostname r5
buggy
!
logging file debug ./slot0r5-log.run
!
vrf definition tester
 exit
!
vrf definition v1
 rd 1:1
 exit
!
vrf definition v2
 rd 1:2
 rt4import 1:2
 rt4export 1:2
 rt6import 1:2
 rt6export 1:2
 clr4import 2
 clr4export 2
 clr6import 2
 clr6export 2
 exit
!
vrf definition v3
 rd 1:3
 rt4import 1:3
 rt4export 1:3
 rt6import 1:3
 rt6export 1:3
 clr4import 3
 clr4export 3
 clr6import 3
 clr6export 3
 exit
!
interface loopback0
 vrf forwarding v1
 ipv4 address 2.2.2.5 255.255.255.255
 ipv6 address 4321::5 ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
 no shutdown
 no log-link-change
 exit
!
interface loopback2
 vrf forwarding v2
 ipv4 address 3.3.3.5 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface loopback3
 vrf forwarding v3
 ipv4 address 4.4.4.5 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding v1
 ipv4 address 1.1.1.10 255.255.255.252
 mpls enable
 no shutdown
 no log-link-change
 exit
!
interface ethernet2
 lldp enable
 vrf forwarding v2
 ipv4 address 6.6.6.1 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
interface ethernet3
 lldp enable
 vrf forwarding v3
 ipv4 address 6.6.6.5 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
router bgp4 2 vrf v1
 upgrade-cli
 local-as 2
 router-id 2.2.2.5
 no safe-ebgp
 address-family unicast
 neighbor 1.1.1.9 remote-as 1
 neighbor 1.1.1.9 local-as 2
 neighbor 1.1.1.9 address-family ctp
 neighbor 1.1.1.9 distance 20
 neighbor 1.1.1.9 send-community all
 afi-clr v2 enable
 afi-clr v2 redistribute connected
 afi-clr v3 enable
 afi-clr v3 redistribute connected
 redistribute connected
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r6:**
```
hostname r6
buggy
!
logging file debug ./slot0r6-log.run
!
vrf definition tester
 exit
!
vrf definition v1
 rd 1:1
 exit
!
interface loopback0
 vrf forwarding v1
 ipv4 address 2.2.2.6 255.255.255.255
 ipv6 address 4321::6 ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding v1
 ipv4 address 6.6.6.2 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
ipv4 route v1 0.0.0.0 0.0.0.0 6.6.6.1
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r7:**
```
hostname r7
buggy
!
logging file debug ./slot0r7-log.run
!
vrf definition tester
 exit
!
vrf definition v1
 rd 1:1
 exit
!
interface loopback0
 vrf forwarding v1
 ipv4 address 2.2.2.7 255.255.255.255
 ipv6 address 4321::7 ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding v1
 ipv4 address 6.6.6.6 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
ipv4 route v1 0.0.0.0 0.0.0.0 6.6.6.5
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```
